package models

import (
	"lapp_-wy/db"
	"lapp_-wy/utils"
	"xorm.io/core"
	"errors"
)

type Propertytypetab struct {
	Cid                    int     `json:"cid" xorm:"not null pk INT(4)"`
	Propertytypeid         string  `json:"propertytypeid" xorm:"not null pk VARCHAR(100)"`
	Descr                  string  `json:"descr" xorm:"VARCHAR(255)"`
	Propertytype           string  `json:"propertytype" xorm:"VARCHAR(40)"`
	Propertycate           string  `json:"propertycate" xorm:"VARCHAR(40)"`
	Unitprice              float64 `json:"unitprice" xorm:"DECIMAL(10,2)"`
	Unsoldarea             float64 `json:"unsoldarea" xorm:"DECIMAL(10,2)"`
	Soldvacantarea         float64 `json:"soldvacantarea" xorm:"DECIMAL(10,2)"`
	Soldoccupiedarea       float64 `json:"soldoccupiedarea" xorm:"DECIMAL(10,2)"`
	Totalhouseholds        int     `json:"totalhouseholds" xorm:"INT(4)"`
	Unsoldhouseholds       int     `json:"unsoldhouseholds" xorm:"INT(4)"`
	Soldvacanthouseholds   int     `json:"soldvacanthouseholds" xorm:"INT(4)"`
	Soldoccupiedhouseholds int     `json:"soldoccupiedhouseholds" xorm:"INT(4)"`
	Createtime             string  `json:"createtime" xorm:"VARCHAR(14)"`
	Lastmodifytime         string  `json:"lastmodifytime" xorm:"VARCHAR(14)"`
	Lastmodifyby           string  `json:"lastmodifyby" xorm:"VARCHAR(40)"`
}

func (t *Propertytypetab) TableName() string {
	return "propertytypetab"
}

// 清除string字段的右侧空格
func (t *Propertytypetab) Clipped() {
	utils.TrimStruct(t, *t)
}

//增
func (t *Propertytypetab) Add() error {
	e := db.MasterEngine()
	countrole := new(Propertytypetab)
	affw, err := e.Table("propertytypetab").ID(core.PK{t.Cid, t.Propertytypeid}).Count(countrole)
	if err != nil {
		return err
	}
	if affw > 0 {
		return errors.New("数据已经存在！")
	}
	_, err = e.Table("propertytypetab").Insert(t)
	if err != nil {
		return err
	}
	return nil
}

//删
func (t *Propertytypetab) Del() bool {
	e := db.MasterEngine()
	_, err := e.ID(core.PK{t.Cid, t.Propertytypeid}).Delete(&Propertytypetab{})
	if err != nil {
		return false
	}
	return true
}

//改
func (t *Propertytypetab) Update() bool {
	e := db.MasterEngine()
	_, err := e.ID(core.PK{t.Cid, t.Propertytypeid}).Update(t)
	if err != nil {
		return false
	}
	return true
}

//查
func (t *Propertytypetab) SelectOne() (Propertytypetab, error) {
	e := db.MasterEngine()
	var data Propertytypetab
	_, err := e.ID(core.PK{t.Cid, t.Propertytypeid}).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}

//查
func (t *Propertytypetab) SelectArr() ([]Propertytypetab, error) {
	e := db.MasterEngine()
	data := make([]Propertytypetab,0)
	query := e.Table("propertytypetab").Where("cid = ? ", t.Cid)

	if !utils.ValueIsEmpty(t.Propertytype) {
		query = query.And("propertytype = ?", t.Propertytype)
	}
	err := query.Find(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}

//分页
func (t *Propertytypetab) GetPage(pageSize int, pageIndex int) ([]Propertytypetab, int, error) {
	data := make([]Propertytypetab, 0)
	e := db.MasterEngine()

	query := e.Table("propertytypetab").Where("cid = ? ", t.Cid)
	table := e.Table("propertytypetab").Where("cid = ? ", t.Cid)
	if !utils.ValueIsEmpty(t.Propertytypeid) {
		query = query.And("propertytypeid = ?", t.Propertytypeid)
		table = table.And("propertytypeid = ?", t.Propertytypeid)
	}
	Offset := (pageIndex - 1) * pageSize
	err := query.Limit(pageSize, Offset).Desc("createtime").Find(&data)

	pcount := new(Propertytypetab)
	count, err := table.Count(pcount)
	if err != nil {
		return data, 0, err
	}
	return data, int(count), nil
}
