package models

// 比较大小的接口
type ICompare interface {
	Compare(interface{}) int
}

func (item CatApplyTotal) Compare(iData interface{}) int {
	data, ok := iData.(CatApplyTotal)
	if !ok {
		return -2
	}
	if item.YearDate > data.YearDate {
		return 1
	} else {
		return -1
	}
}

//单园区报销数据统计
type CatApplyTotal struct {
	YearDate            string  `json:"yearDate"`            //日期
	EngineApply         float64 `json:"engineApply"`         //工程报销
	CustomerApply       float64 `json:"customerApply"`       //客服报销
	SecurityApply       float64 `json:"securityApply"`       //保安报销
	CleanApply          float64 `json:"cleanApply"`          //保洁报销
	AdministrativeApply float64 `json:"administrativeApply"` //综合行政报销
	OtherApply          float64 `json:"otherApply"`          //其他报销
	TotalApply          float64 `json:"totalApply"`          //统计报销
}

//园区近年来统计
type TakeYearTotal struct {
	Year  string  `json:"year"`
	Jan   float64 `json:"jan"`
	Feb   float64 `json:"feb"`
	Mar   float64 `json:"mar"`
	Apr   float64 `json:"apr"`
	May   float64 `json:"may"`
	Jun   float64 `json:"jun"`
	Jul   float64 `json:"jul"`
	Aug   float64 `json:"aug"`
	Sep   float64 `json:"sep"`
	Oct   float64 `json:"oct"`
	Nov   float64 `json:"nov"`
	Dec   float64 `json:"dec"`
	Total float64 `json:"total"`
}

func (item TakeYearTotal) Compare(iData interface{}) int {
	data, ok := iData.(TakeYearTotal)
	if !ok {
		return -2
	}
	if item.Year > data.Year {
		return 1
	} else {
		return -1
	}
}

type PropertyFee struct {
	Cid              int     `json:"cid"`              //项目Id
	Cidname          string  `json:"cidname"`          //项目名称
	Buildingid       string  `json:"buildingid"`       //楼栋
	Buildingname     string  `json:"buildingname"`     //楼栋
	Propertytypeid   string  `json:"propertytypeid"`   //物业类型
	Descr            string  `json:"descr"`            //物业类型描述
	Totalhouseholds  int     `json:"totalhouseholds"`  //总户数
	Constructionarea float64 `json:"constructionarea"` //建筑面积
	Unitprice        float64 `json:"unitprice"`        //单价
	StartDate        string  `json:"start_date"`       //开始日期
	EndDate          string  `json:"end_date"`         //结束日期
	LengthDate       int     `json:"length_date"`      //收费周期
	ExpectMoney      float64 `json:"expect_money"`     //预计收费金额
	ReceivableMoney  float64 `json:"receivable_money"` //实际收费金额
	Percent          float64 `json:"percent"`          //收费率
	DifferenceValue  float64 `json:"difference_value"` //差值
}

func (item PropertyFee) Compare(iData interface{}) int {
	data, ok := iData.(PropertyFee)
	if !ok {
		return -2
	}
	if item.Buildingid > data.Buildingid {
		return 1
	} else {
		return -1
	}
}

func BubbleSort(list []ICompare) []ICompare {
	for i := 0; i < len(list); i++ {
		for j := 1; j < len(list)-i; j++ {
			result := list[j].Compare(list[j-1])
			if result == -1 {
				//交换
				list[j], list[j-1] = list[j-1], list[j]
			}
		}
	}
	return list
}
